function [Fma] = Gen_Toeplitz_Filter(n,L)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%% Gera matriz com Filtro Toeplitz %%%%%%%%%%%%%%
%%%%%%% Entradas : (n,L)  Retorna: Fma_ij, 
%%%%%%% onde i = n+L -1 e j = n+L
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% Resposta ao Impulso %%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
h(1:L)= 1;

F = h';

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Faz o deslocamento 1 p direita 1 para baixo %%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i = 2 : n-1+L
    for j = 2 : n+L
        F(i,j)= F(i-1,j-1);
    end
end
        
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%% Fma pertence Fma n-1+L,n+L %%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Fma = F;   
 
 disp('Toeplitz Filter Ok');       