function [X] = Gen_Tx_Signal(p,n,Stx,Vec_Simbol)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Retorna a matriz de Transmissao dependendo do tipo de sinal escolhido
%% pelo usurio: 1-RUIDO, 2-BPSK, 3-MQAM, 4-Customizado
%% Caso o seja escolhido a opo 3, deve-se informar a ordem da modulao
%% cao MQAM, se escolha for 4- deve indicar o caminho de um
%% arquivo .dat, contendo os simbolos que se deseja tranmsitir
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% 1- Rudo %%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if Stx == 1
    for k= 1 : n        
        X(:,k) = (sqrt(2)/2).* randn(p,1) + j*(sqrt(2)/2).*randn(p,1);         
    end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% 2- BPSK Sig %%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%      
elseif Stx == 2
    for i= k : n
        X(:,k) = 2 * (randi([0 1],p,1)-1/2);        
    end 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% 3- MQAM Sig %%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%       
elseif Stx == 3
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%% Recebe o Vector MQAM %%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    Simbolos_Mqam = Vec_Simbol;  
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%% Calculando a energia do vetor de simbolos %%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    Energy = (sum(real(Simbolos_Mqam).^2) + sum(imag(Simbolos_Mqam).^2))/ length(Simbolos_Mqam);
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%% Normalizando vetor de Simbolos %%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    Simbolos_Mqam = Simbolos_Mqam / sqrt(Energy);    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%% Gera Matriz trasmissao X %%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    X = Simbolos_Mqam(randi([1,length(Simbolos_Mqam)],p,n));    
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% 4- CUSTOMIZADO %%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%      
else
    
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%% Entre com vetor de simbolos %%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%% Carrega o arquivo neste ponto%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	Vec_Simbol = Vec_Simbol;
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%% Se User deseja entrar diretamente basta descomentar abaixo %%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%Vec_Simbol = [1 + j*1, -1 + j*1, -1 - j*1, 1 - j*1];
	
	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%% Calculando a energia do vetor de simbolos %%%%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	Energy = (sum(real(Vec_Simbol).^2) + sum(imag(Vec_Simbol).^2))/ length(Vec_Simbol);
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%% Normalizando vetor de Simbolos %%%%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	Vec_Simbol = Vec_Simbol / sqrt(Energy);
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%%% Gera Matriz trasmissao X %%%%%%%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	X = Vec_Simbol(randi([1,length(Vec_Simbol)],p,n));
    
end    
    