function [Pd,Pfa,T_H0,T_H1] = calc_Pd_Pfa_conv(m,n,p,Nevents,Nb,Ns,K,Pin,Pcr,A,B,Beta,Op_IN_Tipe,Detection,Stx,SNR,limiar,Vec_Simbol)
%-----------------------------------------------------------------------%
% Funo que calcula a Pd e Pfa 
%
%-----------------------------------------------------------------------%

cont_d        = 0;
cont_fa       = 0;
cont_total_tx  = 0;
cont_total_ntx = 0;
H = zeros(m,p);
X = zeros(p,n);
V = zeros(m,n);
Y = zeros(m,n);
Aux_1 = zeros(n,m);
T_H0 = zeros(1,Nevents);
T_H1 = zeros(1,Nevents);

for ind = 1 : Nevents
    
    
    %%%%%%%%%%%%%%%%%%%%%%%
	%%% Rido impulsivo %%%
	%%%%%%%%%%%%%%%%%%%%%%%	
	if K > 0
		VI = Gen_Impulsive_Noise(m,n,Nb,Ns,K,Pin,Pcr,A,B,Beta,Op_IN_Tipe,SNR);	
	else	
		VI = zeros(m,n);		
    end
	
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%% Preenche a matriz de canal %%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    [H] = Gen_Channel_H(m,p);	
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%% Preenche a matriz de transmisso %%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
	[X] = Gen_Tx_Signal_X(p,n,Stx,Vec_Simbol);
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%%%%%% Preenche a matriz de ruido %%%%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    V = (sqrt(1/(2*10^(SNR/10)))).* randn(m,n) + j * (sqrt(1/(2*10^(SNR/10)))).* randn(m,n); 
	
	
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%% Matriz Recebida de amostras com uma aleatoriedade inserida hora transmite hora nao transmite%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    I_tx = randi([0 1]);  
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	%%% Leva em conta probabilidade de ocorrencia do ruido impulsivo %%%%
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
    I_ri = binornd(1,Pin);
    Y = I_tx * H * X + V + I_ri .* VI;	 
    g = ones(1,m);
	

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Escolhe qual tipo de mtodo de deteco %
	%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%	
	[T] = Gen_Var_T(Detection,m,n,Y,g,SNR);
    
	% Se T > limiar e transmitiu conta detecao
	cont_d = cont_d + (abs(T) > limiar)*I_tx ;
	% Se T > limiar e nao transmitiu conta FA
	cont_fa = cont_fa + (abs(T) > limiar)* not(I_tx);
	
	% Nmerde vezes que transmitiu dado
	cont_total_tx  = cont_total_tx + I_tx;
	% Nmero de vezes que nao transmitiu dado
	cont_total_ntx = cont_total_ntx + not(I_tx);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%% Para Gerao das pdfs H0 e H1 %%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	if I_tx == 1
	
		T_H1(cont_total_tx) = abs(T);
	
	else
	
		T_H0(cont_total_ntx) = abs(T);
	
	end;





end; % Fim do While

Pd = cont_d / cont_total_tx; 
Pfa = cont_fa / cont_total_ntx;

T_H0 = T_H0;
T_H1 = T_H1;

